﻿' Copyright (c) 2010 Manfred Clemens erst.: 19.06.2010, letzte Änderung: 07.07.2010
' ---------------------------------------------------------------------------------
Option Explicit On                        ' explizite Deklarationen aller Variablen
Option Strict On                          ' strikte Datentypkonvertierungen

#Region " Imports "
Imports MdiApp.clsInitStart
Imports System.Windows.Forms
Imports MdiApp.K8055d                     ' K8055D.DLL Deklarationen
#End Region

Public Class MDIForm

#Region " Form Events "

#Region " ... Load "
  Private Sub MDIForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' ---------------------------------------------------------------------------------
    '                                                                    Formular laden 
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fSettings Is Nothing OrElse clsInitStart.fSettings.IsDisposed Then
      clsInitStart.fSettings = New frmSettings
    End If
    'clsInitStart.fSettings.Show()
    clsInitStart.fConnect.Show()
  End Sub
#End Region

#Region " Menue "

  Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ExitToolStripMenuItem.Click
    ' ---------------------------------------------------------------------------------
    '                                                                    Menü schließen 
    ' ---------------------------------------------------------------------------------
    Me.Close()
  End Sub

  Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
    ' ---------------------------------------------------------------------------------
    '                                                          Menü, Info über anzeigen
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fAbout Is Nothing OrElse clsInitStart.fAbout.IsDisposed Then
      clsInitStart.fAbout = New frmAbout
    End If
    clsInitStart.fAbout.Show()
  End Sub

  Private Sub OpenFile(ByVal sender As Object, ByVal e As EventArgs) Handles OpenToolStripMenuItem.Click
    ' ---------------------------------------------------------------------------------
    '                                                                Menü, Datei öffnen
    ' ---------------------------------------------------------------------------------
    Dim OpenFileDialog As New OpenFileDialog
    OpenFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
    OpenFileDialog.Filter = "Textdateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*"
    If (OpenFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
      Dim FileName As String = OpenFileDialog.FileName
      ' TODO: Hier Code zum Öffnen der Datei hinzufügen
    End If
  End Sub

  Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles SaveAsToolStripMenuItem.Click
    ' ---------------------------------------------------------------------------------
    '                                                               Menü, Datei sichern
    ' ---------------------------------------------------------------------------------
    Dim SaveFileDialog As New SaveFileDialog
    SaveFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
    SaveFileDialog.Filter = "Textdateien (*.txt)|*.txt|Alle Dateien (*.*)|*.*"

    If (SaveFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
      Dim FileName As String = SaveFileDialog.FileName
      ' TODO: Hier Code einfügen, um den aktuellen Inhalt des Formulars in einer Datei zu speichern
    End If
  End Sub

  Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ToolBarToolStripMenuItem.Click
    Me.ToolStrip.Visible = Me.ToolBarToolStripMenuItem.Checked
  End Sub

  Private Sub StatusBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles StatusBarToolStripMenuItem.Click
    Me.StatusStrip.Visible = Me.StatusBarToolStripMenuItem.Checked
  End Sub

  Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CascadeToolStripMenuItem.Click
    Me.LayoutMdi(MdiLayout.Cascade)
  End Sub

  Private Sub TileVerticalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileVerticalToolStripMenuItem.Click
    Me.LayoutMdi(MdiLayout.TileVertical)
  End Sub

  Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles TileHorizontalToolStripMenuItem.Click
    Me.LayoutMdi(MdiLayout.TileHorizontal)
  End Sub

  Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles CloseAllToolStripMenuItem.Click
    ' ---------------------------------------------------------------------------------
    '                                                       Menü-Alle Fenster schließen
    ' ---------------------------------------------------------------------------------
    ' VB.NET hat hierfür eine eigene MDIChildren-Auflistung (Collection)
    ' Anzahl der  aktuell geöffneten Child-Formen
    Dim nCount As Integer
    nCount = Me.MdiChildren.Length
    ' alle geöffneten Child-Formen schließen
    Dim oChild As Form
    For Each oChild In Me.MdiChildren
      oChild.Close()
    Next
  End Sub

  Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
    ' ---------------------------------------------------------------------------------
    '                                                                 Formular anzeigen
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fSettings Is Nothing OrElse clsInitStart.fSettings.IsDisposed Then
      clsInitStart.fSettings = New frmSettings
    End If
    clsInitStart.fSettings.Show()
  End Sub

  Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton2.Click
    ' ---------------------------------------------------------------------------------
    '                                                                 Formular anzeigen
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fConnect Is Nothing OrElse clsInitStart.fConnect.IsDisposed Then
      clsInitStart.fConnect = New frmConnect
    End If
    clsInitStart.fConnect.Show()
  End Sub

  Private Sub ToolStripButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton3.Click
    ' ---------------------------------------------------------------------------------
    '                                                                    Button Trennen  
    ' ---------------------------------------------------------------------------------
    Disconnect()
  End Sub

  Private Sub ToolStripButton4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton4.Click
    ' ---------------------------------------------------------------------------------
    '                                                Formular Digitale Signale anzeigen 
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fDigital Is Nothing OrElse clsInitStart.fDigital.IsDisposed Then
      clsInitStart.fDigital = New frmDigital
    End If
    clsInitStart.fDigital.Show()
  End Sub

  Private Sub ToolStripButton5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton5.Click
    ' ---------------------------------------------------------------------------------
    '                                                 Formular Analoge Signale anzeigen 
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fAnalog Is Nothing OrElse clsInitStart.fAnalog.IsDisposed Then
      clsInitStart.fAnalog = New frmAnalog
    End If
    clsInitStart.fAnalog.Show()
  End Sub

  Private Sub ToolStripButton6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton6.Click
    ' ---------------------------------------------------------------------------------
    '                                                        Formular Temperaturmessung 
    ' ---------------------------------------------------------------------------------
    If clsInitStart.fTemp Is Nothing OrElse clsInitStart.fTemp.IsDisposed Then
      clsInitStart.fTemp = New frmTemp
    End If
    clsInitStart.fTemp.Show()
  End Sub

#End Region

#Region " Procedures "
#Region " ... Disconnect "
  Private Sub Disconnect()
    ' ---------------------------------------------------------------------------------
    '                                                                           Trennen  
    ' ---------------------------------------------------------------------------------
    CloseDevice()
    ToolStripStatusLabel.Image = Nothing
    ToolStripStatusLabel.Text = sConnect
    CardSelected = False
  End Sub
#End Region

#End Region

#End Region

 

 

End Class
