﻿' Copyright (c) 2010 Manfred Clemens erst.: 20.06.2010, letzte Änderung: 26.06.2010
' ---------------------------------------------------------------------------------
Option Explicit On                        ' explizite Deklarationen aller Variablen
Option Strict On                          ' strikte Datentypkonvertierungen

#Region " Imports "
Imports MdiApp.clsInitStart               ' Klasse: Start initialisieren
Imports MdiApp.K8055d                     ' K8055D.DLL Deklarationen
#End Region

Public Class frmDigital

#Region " Members variable declaration's "
  Private n As Integer
  Private cbOutput(8) As CheckBox
#End Region

#Region " Form Events "
#Region " ... Load "
  Private Sub frmDigital_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' ---------------------------------------------------------------------------------
    '                                                                    Formular laden
    ' ---------------------------------------------------------------------------------
    clsInitStart.fDigital.MdiParent = MDIForm
    Dim i As Integer


    If CardSelected = True Then
      Timer1.Enabled = True
    Else
      Timer1.Enabled = False
    End If

    ' Digital Outputs
    For i = 1 To 8
      cbOutput(i) = New System.Windows.Forms.CheckBox
      cbOutput(i).Size = New System.Drawing.Size(50, 16)
      cbOutput(i).Text = CStr(i)
      cbOutput(i).Tag = 2 ^ (i - 1)
      cbOutput(i).Image = My.Resources.DiodeGn
      cbOutput(i).ImageAlign = ContentAlignment.MiddleRight
      cbOutput(i).Location = New System.Drawing.Point(15, 24 * i - 10)
      Me.gbOutputs.Controls.Add(cbOutput(i))
      AddHandler cbOutput(i).Click, AddressOf gbOutputs_CheckedChanged
    Next
  End Sub
#End Region

#Region " Timer "
#Region " ... Timer1 "
  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    ' ---------------------------------------------------------------------------------
    '                                                                             Timer
    ' ---------------------------------------------------------------------------------
    If CardSelected = True Then

      Timer1.Enabled = False

      ReadAllDigitalInputs()

      Timer1.Enabled = True
    End If
  End Sub
#End Region
#Region " ... Timer2 "
  Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
    ' ---------------------------------------------------------------------------------
    '                                                                             Timer
    ' ---------------------------------------------------------------------------------
    If CardSelected = True Then
      Timer2.Interval = Timer2Interval
      ClearDigitalChannel(n)
      If n > 0 And n <= 9 Then
        cbOutput(n).Checked = False
        cbOutput(n).Image = My.Resources.DiodeGn
      End If

      n += 1
      If n = 9 Then n = 1
      SetDigitalChannel(n)
      cbOutput(n).Checked = True
      cbOutput(n).Image = My.Resources.DiodeRed
    End If
  End Sub
#End Region
#End Region

#Region " Button Events "
#Region " ... Button Reset Counter 1 "
  Private Sub btnReset1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset1.Click
    ' ---------------------------------------------------------------------------------
    '                                                              Button Reset Counter
    ' ---------------------------------------------------------------------------------
    ResetCounter(1)
  End Sub
#End Region
#Region " ... Button Reset Counter 2 "
  Private Sub btnReset2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset2.Click
    ' ---------------------------------------------------------------------------------
    '                                                              Button Reset Counter
    ' ---------------------------------------------------------------------------------
    ResetCounter(2)
  End Sub
#End Region
#Region " ... Button Set All Digital Outputs "
  Private Sub btnSetAllDigitalOutputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetAllDigitalOutputs.Click
    ' ---------------------------------------------------------------------------------
    '                                                    Button Set All Digital Outputs
    ' ---------------------------------------------------------------------------------
    Dim i As Integer
    If CardSelected = True Then
      For i = 1 To 8
        cbOutput(i).Checked = True
        cbOutput(i).Image = My.Resources.DiodeRed
      Next
      SetAllDigital()
    End If
  End Sub
#End Region
#Region " ... Button Clear All Digital Outputs "
  Private Sub btnClearAllDigitalOutputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAllDigitalOutputs.Click
    ' ---------------------------------------------------------------------------------
    '                                                  Button Clear All Digital Outputs
    ' ---------------------------------------------------------------------------------
    ClearAllDigitalOutputs()
  End Sub
#End Region
#Region " ... Button Output Test "
  Private Sub cbOutputTest_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbOutputTest.CheckedChanged
    ' ---------------------------------------------------------------------------------
    '                                                                Button Output Test
    ' ---------------------------------------------------------------------------------
    If CardSelected = True And cbOutputTest.Checked = True Then
      Timer2.Enabled = True
    Else
      Timer2.Enabled = False
      For i = 1 To 8
        cbOutput(i).Checked = False
      Next
      ClearAllDigitalOutputs()
    End If
  End Sub
#End Region
#End Region

#Region " Procedures "
#Region " ... Write All Digital Outputs "
  Private Sub gbOutputs_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
    ' ---------------------------------------------------------------------------------
    '                                                         Write All Digital Outputs
    ' ---------------------------------------------------------------------------------
    Dim i As Integer
    Dim n As Integer = 0

    If CardSelected = True Then
      For i = 1 To 8
        If cbOutput(i).Checked Then
          n = n + CInt(cbOutput(i).Tag)
          cbOutput(i).Image = My.Resources.DiodeRed
        Else
          cbOutput(i).Image = My.Resources.DiodeGn
        End If

        WriteAllDigital(n)
      Next
    End If
  End Sub
#End Region
#Region " ... Read All Digital Inputs and Counters "
  Private Sub ReadAllDigitalInputs()
    ' ---------------------------------------------------------------------------------
    '                                              Read All Digital Inputs and Counters
    ' ---------------------------------------------------------------------------------
    ' Read All Digital Inputs
    Dim i As Integer = ReadAllDigital

    If CBool((i And 1)) = True Then
      lblInput1.Image = My.Resources.DiodeRed
    Else
      lblInput1.Image = My.Resources.DiodeGn
    End If

    If CBool((i And 2) \ 2) = True Then
      lblInput2.Image = My.Resources.DiodeRed
    Else
      lblInput2.Image = My.Resources.DiodeGn
    End If

    If CBool((i And 4) \ 4) = True Then
      lblInput3.Image = My.Resources.DiodeRed
    Else
      lblInput3.Image = My.Resources.DiodeGn
    End If

    If CBool((i And 8) \ 8) = True Then
      lblInput4.Image = My.Resources.DiodeRed
    Else
      lblInput4.Image = My.Resources.DiodeGn
    End If

    If CBool((i And 16) \ 16) = True Then
      lblInput5.Image = My.Resources.DiodeRed
    Else
      lblInput5.Image = My.Resources.DiodeGn
    End If

    ' Read Counter 1 & 2
    lblCounter1.Text = ReadCounter(1).ToString
    lblCounter2.Text = ReadCounter(2).ToString
  End Sub
#End Region
#Region " ... Clear All Digital Outputs "
  Private Sub ClearAllDigitalOutputs()
    ' ---------------------------------------------------------------------------------
    '                                                         Clear All Digital Outputs
    ' ---------------------------------------------------------------------------------
    Dim i As Integer
    If CardSelected = True Then
      For i = 1 To 8
        cbOutput(i).Checked = False
        cbOutput(i).Image = My.Resources.DiodeGn
      Next
      ClearAllDigital()
    End If
  End Sub
#End Region
#End Region

#End Region

End Class