﻿' Copyright (c) 2010 Manfred Clemens erst.: 07.07.2010, letzte Änderung: 14.07.2010
' ---------------------------------------------------------------------------------
Option Explicit On                        ' explizite Deklarationen aller Variablen
Option Strict On                          ' strikte Datentypkonvertierungen

#Region " Imports "
Imports MdiApp.clsInitStart               ' Klasse: Start initialisieren
Imports MdiApp.K8055d                     ' K8055D.DLL Deklarationen
Imports MdiApp.clsGlobal                  ' eigene Klasse
Imports System.IO       ' Lesen und Schreiben für Dateien und Datenstreams zulassen

#End Region


Public Class frmTemp

#Region " Form Events "

#Region " ... Load "

  Private Sub frmTemp_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' ---------------------------------------------------------------------------------
    '                                                                    Formular laden
    ' ---------------------------------------------------------------------------------
    clsInitStart.fTemp.MdiParent = MDIForm

    GTrackBarInput1.Cursor = Cursors.No

    cboTimerIntervalAnalogInputs.SelectedIndex = 0

    If CardSelected = True Then
      Timer1.Enabled = True
      LogFile("Messung gestartet")

    Else
      Timer1.Enabled = False
    End If


  End Sub

  Private Sub frmTemp_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    ' ---------------------------------------------------------------------------------
    '                                                                Formular schließen 
    ' ---------------------------------------------------------------------------------
    LogFile("Messung beendet")

  End Sub

#End Region

#Region " ... Protokolldatei auslesen"
  Private Sub ReadLogFile()
    ' ---------------------------------------------------------------------------------
    '                                                 Protokolldatei (LogFile) auslesen
    ' ---------------------------------------------------------------------------------
    Try
      Dim pfad As String = Environment.CurrentDirectory & "\LogFile.txt"
      Dim FiStr As FileStream = New FileStream(pfad, FileMode.Open)  ' lesen
      Dim StrRe As StreamReader = New StreamReader(FiStr)
      Dim i As Integer
      lbLogFile.Items.Clear()
      Do Until StrRe.Peek() = -1
        lbLogFile.Items.Add(StrRe.ReadLine)
        i += 1
      Loop
      StrRe.Close()
    Catch except As Exception
      MsgBox(except.Message & vbNewLine & _
             "Die Protokolldatei (LogFile.txt) wurde nicht gefunden!", MsgBoxStyle.Exclamation)
    End Try
  End Sub
#End Region

  Private Sub btnReadLogFile_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadLogFile.Click
    ReadLogFile()
  End Sub

#Region " Timer "
  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    ' ---------------------------------------------------------------------------------
    '                                                                             Timer
    ' ---------------------------------------------------------------------------------
    If CardSelected = True Then
      'Timer1.Interval = Timer1Interval
      Timer1.Interval = CInt(cboTimerIntervalAnalogInputs.SelectedItem) * 1000
      Timer1.Enabled = False

      Dim Data1, Data2 As Integer
      ' Data = 0 = 0 Volt; Data = 255 = 5 Volt
      ReadAllAnalog(Data1, Data2)

      GTrackBarInput1.Value = Data1

      ' Messwert in Temperatur umrechnen in °C anzeigen
      Dim t1 As Double = (101 * Data1 / 256) - 23
      Dim st1 As String = t1.ToString("0.0")
      lblTemp1.Text = st1

      ' Messwerte in Log-File schreiben
      LogFile(Data1.ToString & vbTab & st1 & vbTab & Data2.ToString)

      Timer1.Enabled = True
    End If
  End Sub
#End Region

#End Region



End Class